DateFormatProvider (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.text.spi, class: DateFormatProvider
Keywords: java.text.spi.DateFormatProvider class

# Class DateFormatProvider

java.lang.Object
java.util.spi.LocaleServiceProvider
java.text.spi.DateFormatProvider

public abstract class DateFormatProvider extends LocaleServiceProvider
An abstract class for service providers that provide concrete implementations of the `DateFormat` class.

Since:
  1.6

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `DateFormatProvider()`
  Sole constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract DateFormat`
  `getDateInstance(int style, Locale locale)`
  Returns a new `DateFormat` instance which formats date with the given formatting style for the specified locale.
  `abstract DateFormat`
  `getDateTimeInstance(int dateStyle, int timeStyle, Locale locale)`
  Returns a new `DateFormat` instance which formats date and time with the given formatting style for the specified locale.
  `abstract DateFormat`
  `getTimeInstance(int style, Locale locale)`
  Returns a new `DateFormat` instance which formats time with the given formatting style for the specified locale.

  ### Methods declared in class LocaleServiceProvider

  `getAvailableLocales, isSupportedLocale`
  Modifier and Type
  Method
  Description
  `abstract Locale[]`
  `getAvailableLocales()`
  Returns an array of all locales for which this locale service provider can provide localized objects or names.
  `boolean`
  `isSupportedLocale(Locale locale)`
  Returns `true` if the given `locale` is supported by this locale service provider.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### DateFormatProvider

    protected DateFormatProvider()
    Sole constructor. (For invocation by subclass constructors, typically implicit.)

- ## Method Details

  - ### getTimeInstance

    public abstract DateFormat getTimeInstance(int style, Locale locale)
    Returns a new `DateFormat` instance which formats time with the given formatting style for the specified locale.
    Parameters:
      `style` - the given formatting style. Either one of `DateFormat.SHORT`, `DateFormat.MEDIUM`, `DateFormat.LONG`, or `DateFormat.FULL`.
      `locale` - the desired locale.
    Returns:
      a time formatter.
    Throws:
      `IllegalArgumentException` - if `style` is invalid, or if `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `locale` is null
    See Also:
      - `DateFormat.getTimeInstance(int, java.util.Locale)`

  - ### getDateInstance

    public abstract DateFormat getDateInstance(int style, Locale locale)
    Returns a new `DateFormat` instance which formats date with the given formatting style for the specified locale.
    Parameters:
      `style` - the given formatting style. Either one of `DateFormat.SHORT`, `DateFormat.MEDIUM`, `DateFormat.LONG`, or `DateFormat.FULL`.
      `locale` - the desired locale.
    Returns:
      a date formatter.
    Throws:
      `IllegalArgumentException` - if `style` is invalid, or if `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `locale` is null
    See Also:
      - `DateFormat.getDateInstance(int, java.util.Locale)`

  - ### getDateTimeInstance

    public abstract DateFormat getDateTimeInstance(int dateStyle, int timeStyle, Locale locale)
    Returns a new `DateFormat` instance which formats date and time with the given formatting style for the specified locale.
    Parameters:
      `dateStyle` - the given date formatting style. Either one of `DateFormat.SHORT`, `DateFormat.MEDIUM`, `DateFormat.LONG`, or `DateFormat.FULL`.
      `timeStyle` - the given time formatting style. Either one of `DateFormat.SHORT`, `DateFormat.MEDIUM`, `DateFormat.LONG`, or `DateFormat.FULL`.
      `locale` - the desired locale.
    Returns:
      a date/time formatter.
    Throws:
      `IllegalArgumentException` - if `dateStyle` or `timeStyle` is invalid, or if `locale` isn't one of the locales returned from `getAvailableLocales()`.
      `NullPointerException` - if `locale` is null
    See Also:
      - `DateFormat.getDateTimeInstance(int, int, java.util.Locale)`